﻿Module Module1
    Declare Function pl1000OpenUnit Lib "pl1000.dll" (ByRef handle As Short) As Integer
    Declare Function pl1000CloseUnit Lib "pl1000.dll" (ByVal handle As Short) As Integer
    Declare Function pl1000SetTrigger Lib "pl1000.dll" (ByVal handle As Short, ByVal enabled As UShort, ByVal enable_auto As UShort, ByVal auto_ms As UShort, ByVal channel As UShort, ByVal dir As UShort, ByVal threshold As UShort, ByVal hysterisis As UShort, ByVal delay As Single) As Short
    Declare Function pl1000SetInterval Lib "pl1000.dll" (ByVal handle As Short, ByRef us_for_block As UInteger, ByVal ideal_no_of_samples As UInteger, ByRef channels As Short, ByVal No_of_channels As Short) As Integer
    Declare Function pl1000GetValues Lib "pl1000.dll" (ByVal handle As Short, ByRef values As UShort, ByRef no_of_values As UInteger, ByRef overflow As UShort, ByRef triggerIndex As UInteger) As Integer
    Declare Function pl1000Run Lib "pl1000.dll" (ByVal handle As Short, ByVal no_of_values As UInteger, ByVal method As Short) As Short
    Declare Function pl1000Ready Lib "pl1000.dll" (ByVal handle As Short, ByRef ready As Short) As Integer
    Declare Function pl1000MaxValue Lib "pl1000.dll" (ByVal handle As Short, ByRef maxValue As UShort) As Integer
    Declare Function pl1000SetDo Lib "pl1000.dll" (ByVal handle As Short, ByVal do_value As Short, ByVal doNo As Short) As Integer
End Module
Public Class Form1
    Dim status As Integer
    Dim handled As Short
    Dim opened As Short
    Dim samples(2000) As UShort
    Dim channels(1) As Short
    Dim nSamples As Integer = 1000
    Dim ready As Short
    Dim us_for_block As Integer = 1000
    Dim maxValue As Short
    Dim triggerIndex As UInteger
    Dim overflow As UShort
    Dim avalues As Integer
    Dim bvalues As Integer

    Function adc_to_mv(ByVal value As Integer) As Integer
        adc_to_mv = value / maxValue * 2500
    End Function
    Private Sub Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenUnit.Click
        status = pl1000OpenUnit(handled)
        opened = handled <> 0
        If opened Then
            status = pl1000SetDo(handled, 1, 0)
            MsgBox("DO now turned on for DO 0")
            status = pl1000MaxValue(handled, maxValue)
            status = pl1000SetTrigger(handled, True, 0, 0, 1, 1, (0.6 * maxValue), 0, -10)
            MsgBox("Trigger Now Set to Channel 1 with a threshold of 1.5V falling edge")
            channels(0) = 1
            channels(1) = 2
            status = pl1000SetInterval(handled, us_for_block, nSamples, channels(0), 2)
            status = pl1000Run(handled, nSamples, 0)
            Do
                status = pl1000Ready(handled, ready)
                If ready Then
                    Exit Do
                End If
            Loop
            MsgBox("Trigger Met")
            status = pl1000GetValues(handled, samples(0), nSamples, overflow, triggerIndex)
            For i = 0 To nSamples - 1
                avalues = adc_to_mv(samples(2 * i))
                bvalues = adc_to_mv(samples(2 * i + 1))
            Next i
            'process data
        End If
    End Sub

    Private Sub Close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseUnit.Click
        pl1000CloseUnit(handled)
    End Sub
End Class

